-------------------------------------------------------------------------------
-- File name : inst_address.vhd
-- Title     : Instruction decoding to address microprogramming
-- project   : ECE 485
-- Library   : multi-cycle processor
-- Author(s) : Ivan Castellanos
-- Purpose   : definition of multi-cycle processor
-- notes :   

-- Copyright Illinois Institute of Technology
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity inst_address is
  port (inst    : in  std_logic_vector(6 downto 0);	
        romaddr : out std_logic_vector(5 downto 0));
end inst_address;

architecture behavior of inst_address is

  signal addr_default: std_logic_vector(5 downto 0);

begin

  --addr_default <= "100110";	-- default address for other op exception

  romaddr(5) <= (not inst(6) and not inst(5) and not inst(4) and not inst(3) and not inst(2) and not inst(1)
                 and inst(0)) or (not inst(6) and inst(5) and not inst(4) and inst(3) and inst(2)) or
                (not inst(5)  and not inst(4) and not inst(3) and inst(2)) or
                (not inst(5) and inst(4) and inst(3)) or (inst(6) and inst(4)) or
                (inst(6) and not inst(2)) or (inst(6) and not inst(3));

  romaddr(4) <= (not inst(6) and inst(5) and inst(4) and inst(3) and inst(2)) or
                (not inst(6)
                 and not inst(5) and inst(4) and not inst(3) and inst(2)) or
                (not inst(6) and not inst(5) and not inst(4)
                 and inst(3) and not inst(2)) or
                (not inst(6) and not inst(5) and not inst(4) and inst(3) and inst(2)) or
                (not inst(6) and not inst(5) and inst(4) and not inst(3) and not inst(2));

  romaddr(3) <= (not inst(6) and not inst(5) and inst(4) and not inst(3) and inst(2)) or
                (inst(6)
                 and inst(5) and not inst(4) and inst(3) and inst(2)) or
                (not inst(6) and not inst(5) and not inst(4)
                 and inst(3) and not inst(2)) or
                (not inst(6) and not inst(5) and not inst(4) and inst(3) and inst(2)) or (
                  not inst(6) and inst(5) and not inst(2)) or
                (not inst(6) and inst(5) and not inst(3));

  romaddr(2) <=(not inst(6) and not inst(5) and not inst(4) and not inst(3) and not inst(2) and inst(1)) or
                (not inst(6) and inst(5) and not inst(4) and inst(3) and inst(2)) or
                (inst(6) and inst(5) and not inst(4)
                 and inst(3) and inst(2)) or
                (not inst(6) and not inst(5) and not inst(4) and inst(3) and inst(2)) or (
                  not inst(6) and not inst(5) and inst(4) and not inst(3) and not inst(2)) or
                (not inst(5) and not inst(4)
                 and not inst(3) and inst(2)) or (not inst(5) and inst(4) and inst(3)) or (inst(6) and inst(4)) or (
                   inst(6) and not inst(2)) or (inst(6) and not inst(3));

  romaddr(1) <= (not inst(6) and not inst(5) and not inst(4) and not inst(3) and not inst(2) and inst(1)) or
                (not inst(5) and not inst(4) and not inst(3) and inst(2)) or
                (not inst(6) and inst(5) and not inst(3)) or (
                  inst(3)) or (inst(6) and not inst(3));

  romaddr(0) <= (not inst(6) and not inst(5) and not inst(4) and not inst(3) and not inst(2) and not inst(1)
                 and inst(0)) or (not inst(6) and not inst(5) and not inst(4) and not inst(3) and not inst(2) and inst(1)) or (
                   not inst(6) and inst(5) and inst(4) and inst(3) and inst(2)) or
                (inst(6) and inst(5) and not inst(4)
                 and inst(3) and inst(2)) or (not inst(6) and not inst(5) and not inst(4) and inst(3) and not inst(2)) or (
                   not inst(6) and not inst(5) and inst(4) and not inst(3) and not inst(2)) or
                (not inst(6) and inst(5)
                 and not inst(2)) or (not inst(6) and inst(5) and not inst(3));

end behavior;


